;;; -*- Mode: Lisp; Package: CL-USER -*-

(in-package "CL-USER")

(unless (find-package :cxml)
  (error "Assumes cxml is already loaded."))

(eval-when (:compile-toplevel)
  (error "Not to be compiled."))

(defvar *this-dir* (make-pathname :name nil :type nil :defaults *load-truename*))

(defvar +dtd-path+ *this-dir*)

(defun default-entity-resolver (public-id system-id)
  (declare (ignore public-id))
  (when (eq (puri:uri-scheme system-id) :http)
    (let* ((uri-path (puri:uri-path system-id))
	   (dtd-filename (subseq uri-path (1+ (position #\/ uri-path :test #'char= :from-end t))))
	   (dtd-path (merge-pathnames (pathname dtd-filename) +dtd-path+)))
      (open dtd-path :element-type '(unsigned-byte 8)))))

(cxml:parse-file (make-pathname :name "redirect" :type "xml" :defaults *this-dir*)
		 (rune-dom:make-dom-builder) :entity-resolver #'default-entity-resolver)

;;; EOF
